#version 330

layout (location = 0) in vec3 pos;
layout (location = 1) in vec2 tex;
layout (location = 2) in vec3 norm;
layout (location = 3) in vec3 tangent;
layout (location = 4) in vec3 bitangent;

out vec4 vCol;
out vec2 TexCoord;
out mat3 TBN;
out vec3 FragPos;
out vec4 FragPosLightSpace;

uniform mat4 model;
uniform mat4 projection;
uniform mat4 view;
uniform float animateTime;
uniform mat4 lightSpaceMatrix;


void main()
{
	
	vec3 pos1 = pos + sin(animateTime) * norm ;
	gl_Position = projection * view * model * vec4(pos1, 1.0);
	vCol = vec4(1.0f, 0.0f, 0.0f, 1.0f);
	
	TexCoord = tex;
	
	//Normal = mat3(transpose(inverse(model))) * norm;
	
	FragPos = (model * vec4(pos1, 1.0)).xyz; 

	
	FragPosLightSpace = lightSpaceMatrix * vec4(pos1, 1.0); 

	
   vec3 T = normalize(vec3(model * vec4(tangent,   0.0)));
   vec3 B = normalize(vec3(model * vec4(bitangent, 0.0)));
   vec3 N = normalize(vec3(model * vec4(norm,    0.0)));
   TBN = mat3(T, B, N);
}