#version 330 core

in vec2 TexCoord;

out vec4 FragColor;

uniform sampler2D renderedTexture;
uniform sampler2D bloomBlur;
uniform float exposure;

void main()
{             
    const float gamma = 2.2;
    vec3 hdrColor = texture(renderedTexture, TexCoord).rgb;      
    vec3 bloomColor = texture(bloomBlur, TexCoord).rgb;
    hdrColor += bloomColor * 0.15; // additive blending
    FragColor = vec4(hdrColor,1);
    return;

    // TODO: fix tone mapping
    // tone mapping
    vec3 result = vec3(1.0) - exp(-hdrColor * exposure);
    // also gamma correct while we're at it       
    result = pow(result, vec3(1.0 / gamma));
    FragColor = vec4(result, 1.0);
}
