#version 330

//uniform vec4 color;
uniform sampler2D theTexture;
uniform float opacity = 1;
uniform bool flip = false;
uniform float contrast;
uniform float brightness;
in vec2 TexCoord;

layout(location = 0) out vec4 glColor;

void main() {
	vec2 texCoord = flip ? vec2(TexCoord.x, -TexCoord.y) : TexCoord;
	glColor =  texture(theTexture, texCoord);
	glColor.rgb = glColor.rgb * contrast + brightness;
	glColor.a *= opacity;
}